[tox]
requires =
    tox>=4.23.2
    tox-uv>=1.17
env_list =
    fix
    3.13
    3.12
    3.11
    3.10
    3.9
    docs
    type
    pkg_meta
skip_missing_interpreters = true

[testenv]
description = run the unit tests with pytest under {base_python}
package = wheel
wheel_build_env = .pkg
extras =
    testing
pass_env =
    DIFF_AGAINST
    PYTEST_*
set_env =
    COVERAGE_FILE = {work_dir}/.coverage.{env_name}
    COVERAGE_PROCESS_START = {tox_root}/pyproject.toml
    _COVERAGE_SRC = {env_site_packages_dir}/sphinx_argparse_cli
commands =
    pytest {tty:--color=yes} {posargs: \
      --junitxml {work_dir}{/}junit.{env_name}.xml --cov {env_site_packages_dir}{/}pyproject_api \
      --cov {tox_root}{/}tests --cov-fail-under=100 \
      --cov-config=pyproject.toml --no-cov-on-fail --cov-report term-missing:skip-covered --cov-context=test \
      --cov-report html:{env_tmp_dir}{/}htmlcov --cov-report xml:{work_dir}{/}coverage.{env_name}.xml \
      tests}

[testenv:fix]
description = run static analysis and style check using flake8
package = skip
deps =
    pre-commit-uv>=4.1.4
pass_env =
    HOMEPATH
    PROGRAMDATA
commands =
    pre-commit run --all-files --show-diff-on-failure
    python -c 'print("hint: run {envdir}/bin/pre-commit install to add checks as pre-commit hook")'

[testenv:docs]
description = build documentation
extras =
    docs
commands =
    sphinx-build -d "{env_tmp_dir}{/}doc_tree" docs "{work_dir}{/}docs_out" --color -b html {posargs: -W}
    python -c 'print(r"documentation available under file://{work_dir}{/}docs_out{/}index.html")'

[testenv:type]
description = run type check on code base
deps =
    mypy==1.14.1
set_env =
    {tty:MYPY_FORCE_COLOR = 1}
commands =
    mypy src
    mypy tests

[testenv:pkg_meta]
description = check that the long description is valid
skip_install = true
deps =
    check-wheel-contents>=0.6.1
    twine>=6.0.1
    uv>=0.5.18
commands =
    uv build --sdist --wheel --out-dir {env_tmp_dir} .
    twine check {env_tmp_dir}{/}*
    check-wheel-contents --no-config {env_tmp_dir}

[testenv:dev]
description = generate a DEV environment
package = editable
extras =
    testing
commands =
    uv pip tree
    python -c 'import sys; print(sys.executable)'
